/*****************************************************************************/
//    ArrayArg.C
/*****************************************************************************/

#include "Globals.h"
#include "ArrayArg.h"

#include "SymbolArg.h"

/*****************************************************************************/

char *corArrayDestructorString = "destruct";
char *corArrayConstructorString = "array";
char *corArrayLookupString = "lookup";
char *corArrayBindString = "bind";

extern Name corArrayConstructSymbol;

/*****************************************************************************/
int corArrayArg::equals(corArg *arg)
{
    if (arg->kindof() != COR_CONST_ARG ||
        ((corConstArg*)arg)->subkind() != COR_ArrayKind)
            return 0;
    else
        return this == arg;
}

/*****************************************************************************/
void corArrayArg::sprint(char *, int *, corBindEnv *) const
{
    fprintf(corexEnv->error_file, "Sorry:  Array::sprint() not implemented\n");
}

/*****************************************************************************/
void corArrayArg::dump(int , FILE *)
{
    fprintf(corexEnv->error_file, "Sorry:  Array::dump() not implemented\n");
}

/*****************************************************************************/

