/*****************************************************************************/
//    StackMark.h
/*****************************************************************************/

#ifndef _StackMark_H_
#define _StackMark_H_

#include "Trail.h"

/*****************************************************************************/
//    Currently trail is a global variable.  It should probably be made a 
//    parameter to StackMark, but currently isn't since it is less efficient. 

class corStackMark {
    int trail_size;        // Size of trail when mark is made.

public:
    // The following form should be used eventually.
    // StackMark(Trail &trail=NULL) { trail_size = CurTrail->TrailSize; }
    
    inline trail_index()    { return trail_size; }
    inline corStackMark()        { trail_size = corCurTrail->TrailSize; }
    inline void get_mark()    { trail_size = corCurTrail->TrailSize; }
    inline void pop_to() {
        // Pop the Trail upto stackmark; 
        corCurTrail->PopTrail(trail_size) ;
    }
};

/*****************************************************************************/

#endif _StackMark_H_

