// *************************************************************************
//    Trail.C
// *************************************************************************

#include "Trail.h"

// *************************************************************************
// The Trail is a stack of TrailElements, which are (bindenv,variable) pairs.
// It is used to remember information that can be undone by PopTrail.
// If a TrailElement.var is non-negative, it marks a binding that as
// been pushed so that PopTrail can undo it.
// If the index is negative, the entire bindenv is to be deleted by PopTrail
// *************************************************************************

//   Trail* CurTrail = new Trail(200);
// has been moved to Globals.C to ensure it is constructed before other
// globals that attempt to use it!


// *************************************************************************
corTrail::corTrail(int size)
{
    Limit = size;
    //Stack = (TrailElement *) malloc(Limit*sizeof(TrailElement)) ;
    Stack = new TrailElement[Limit];
    TrailSize = 0;
}

// *************************************************************************
// Pop the Tail until it has size 'new_size', undoing PushTrails as indicated.

/********   moved as inline to term.h
void Trail::PopTrail(int new_size)
{
    while (TrailSize > new_size) {
    TrailSize--;
    if (Stack[TrailSize].var >= 0) {
//    if ((Stack[TrailSize].var >= 0) && (Stack[TrailSize].bindenv)) {
      ((Stack[TrailSize]).bindenv)->bind(Stack[TrailSize].var, NullTerm);
        // if ( ! Stack[TrailSize].bindenv->is_versioned)
        // (*(Stack[TrailSize].bindenv))[Stack[TrailSize].var] = NullTerm;
        // Don't undo bindings for persistent versioned bindenvs! ?????
    }
    else{
        delete Stack[TrailSize].bindenv ;
    }

    }
}
******/

// *************************************************************************

