/*****************************************************************************/
//    BuiltinCompareRelation.h
/*****************************************************************************/

#ifndef _BuiltinCompareRelation_H_
#define _BuiltinCompareRelation_H_

#include "BuiltinRelation.h"

/*****************************************************************************/

typedef int (*CompareProc)(corTerm& arg0, corTerm& arg1);

/*****************************************************************************/

class corBuiltinCompareRelation : public corBuiltinRelation {
public:
    CompareProc op;

    corBuiltinCompareRelation(int a, Name n, CompareProc bin_op);

    virtual corBindEnv* get_next(corTupleIterator&);
    int is_printable_builtin() {return 0;}
};

/*****************************************************************************/

#endif _BuiltinCompareRelation_H_

