/*****************************************************************************/
//    BacktrackInfoArray.h
/*****************************************************************************/

#ifndef _BacktrackInfoArray_H_
#define _BacktrackInfoArray_H_

#include "RuleInfoArray.h"

/*****************************************************************************/
// Backtrack information corresponding to the RuleInfoArray of the
// QFModuleData structure

struct corBacktrackInfoArray {
public:
    int numRules;
    int** firstFailureBacktrackArrays;    // size of array is numRules
    int** nextFailureBacktrackArrays;    // size of array is numRules
    int* successBacktrackPoints;        // size of array is numRules

    corBacktrackInfoArray(corRuleInfoArray *, int non_ground);
};

/*****************************************************************************/

#endif _BacktrackInfoArray_H_

