//**************************************************************************
//    Scanner.h
//**************************************************************************

#ifndef _Scanner_H_
#define _Scanner_H_

#include <stdio.h>

#include "Config.h"
#include "CArg.h"

//**************************************************************************

struct corSymbol;
struct corsip;
struct corsips;
class  corLiteral;
class  corArg;
struct RuleAnnoList;
struct corRuleAnno;
struct corRuleAnnoCase;
struct corRuleAnnoCaseName;
struct corRuleAnnoCaseDetails;


//**************************************************************************

union corC_arbtype{
    corLiteral* pred;
    corCArg* carg;
    corSymbol*   NameArg;
    char*  str;
    struct corsip* sip;
    struct corsips* sips;
    struct corAliasList* alias_list;
    struct corRuleAnno* rule_anno;
    struct corRuleAnnoCase* anno_case;
    struct corRuleAnnoCaseName* anno_case_name;
    struct corRuleAnnoCaseDetails* anno_case_details;
    int integer;
} ;

//    For Flex compatibility 
#define YYSTYPE corC_arbtype

//**************************************************************************

extern Name corEnterSymbol(const char *);

//**************************************************************************

#endif _Scanner_H_
