// Suspension.h

// list of suspendContext

const int cormax_suspensions= 500;

const int corserver_page_length = 512;
extern int corconvert_ans_2_set(int ans);
class corSuspendContext;

class corsuspensionClass {
  corSuspendContext *context[cormax_suspensions];
  int avail_id(void);        /* next available id for suspension */
 public:
  int set;//global flag for suspension, set = 1: suspend now,
                /* VALUE BEFORE CALLING EVAL: */
                /* set ==-1, don't suspend */
                /* set == 1 + number of answers to generate */
                /* set == 0, suspend upto a page */
  int byte_count;
  corsuspensionClass();
 ~corsuspensionClass();
  int resume(int id);
  int kill(int id);        // to kill an suspended id
    // To kill all suspends of a user
  int killall(int conn_id, int user_id);  
  int suspend(corSuspendContext* s);
  int list(int id);        // list someone's suspended query
};

extern corsuspensionClass corsuspension;







