// *************************************************************************
//    ModuleEnv.C
// *************************************************************************

#include "ModuleEnv.h"

#include "QFMaterializedModuleData.h"

// *************************************************************************
corModuleEnv::corModuleEnv(corQFMaterializedModuleData *parent)
{
    parent_md = parent;
    numSccs = parent->numSccs;
    scc_envs = new corSccEnv *[numSccs];

    for (int i=0; i< numSccs; i++)
        scc_envs[i] = new corSccEnv(parent->sccArray[i]);
}

// *************************************************************************
corModuleEnv::~corModuleEnv()
{
    for (int i=0; i < numSccs; i++)
        delete scc_envs[i];
    delete [] scc_envs;
}

// *************************************************************************
