/****************************************************************************/
//    TermGArray.C
/****************************************************************************/

#include "TermGArray.h"

/****************************************************************************/

// GArrayBindEnvs: This should use C++ templates !!! - PRAVEEN

//GArrayImplement(Term);

/****************************************************************************/
corTerm_garray::corTerm_garray(int tsize, int inc, int tlimit)  
{                    
  size = tsize;            
  if (tlimit < 0) _limit = size;    
  else _limit = tlimit;    
  incr = inc;    
    if (size<incr) incr = size;
    if (tsize <= 0) tarray = NULL;           
    else  tarray = new corTerm *[ceil_div(tsize,inc)];
    corC_NewGArraySize += ceil_div(tsize,inc)*sizeof(corTerm *);
    for(int i=0;i<ceil_div(tsize,inc);i++) tarray[i]=NULL;  
    }                                
                                
/****************************************************************************/
int corTerm_garray::resize(int newsize)             
{                                
  int i;                            
  if(newsize <= size) { size = newsize; return 0;}    
  if (_limit < newsize) _limit = newsize;            
  corTerm **newarray = new corTerm *[ceil_div(newsize,incr)];
  for(i=0;i<ceil_div(size,incr);i++)         
    newarray[i]=tarray[i];        
  for(i=ceil_div(size,incr);i<ceil_div(newsize,incr);i++)
    newarray[i]=NULL;                   
  corC_NewGArraySize += (newsize - size)*sizeof(corTerm *);
  size = newsize;        
  delete tarray;        
  tarray = newarray;    
  return 0;        
}                

/****************************************************************************/
corTerm_garray * corTerm_garray::make_copy()        
{                            
  int i,j;                    
  corTerm_garray *copy = new corTerm_garray;        
  
  copy->size = size;                
  copy->_limit = _limit;                
  copy->incr = incr;                
  if(size<=0)    copy->tarray = NULL;        
  else copy->tarray = new corTerm *[ceil_div(size,incr)];    
  corC_NewGArraySize += size * sizeof(corTerm *);
  for(i=0;i<ceil_div(size,incr);i++){
    if(tarray[i]) {            
      copy->tarray[i] = new corTerm[incr];    
      for (j=0;j<incr;j++)            
    copy->tarray[i][j] = tarray[i][j];    
      corC_NewGArraySize += incr*sizeof(corTerm);
    }                    
    else copy->tarray[i] = NULL;            
  }                        
  return (copy) ;                    
}                            

/****************************************************************************/
int corTerm_garray::get_next(int i)            
{                            
  if ( !tarray ) return(-1);            
  for(i++;i<size;){                
    if (! tarray[i/incr])                
      i = ((i/incr)+1)*incr;            
    else break;                    
  }                        
  return(i);                    
}                            

/****************************************************************************/
corTerm_garray::~corTerm_garray()            
{                            
  if (!tarray) return;                
  for(int i=0; i< ceil_div(size,incr);i++) {    
    if(tarray[i]) {                
      delete tarray[i];            
      corC_DeleteGArraySize += incr*sizeof(corTerm);
    }                        
  }                        
  delete tarray ;        
  corC_DeleteGArraySize += ceil_div(size,incr)*sizeof(corTerm *);
}

/****************************************************************************/

