// *************************************************************************
//	SipGen.h
// *************************************************************************

#ifndef _SipGen_H_
#define _SipGen_H_

#include "ClauseInfo.h"

#include "VarArg.h"
#include "Rule.h"

/*****************************************************************************/

void create_sips();

int setup_arg(corVarArg *arg, void *data);
void setup_vars(corClause *rule, ClauseInfo *rule_info);

void cleanup_vars(ClauseInfo *rule_info);

void gen_sip_rule(ClauseInfo *rule_info, corBitVector& adorn);

/*****************************************************************************/

#endif _SipGen_H_

