/*****************************************************************************/
//    HashNode.h
/*****************************************************************************/

#ifndef _HashNode_H_
#define _HashNode_H_

#include "NumArg.h"
#include "CArg.h"
/*****************************************************************************/

class corHeapNode {
public:
    corTuple *tuple;
    corCArg val;
    corHeapNode *left;
    corHeapNode *right;
    int weight;
  
    corHeapNode(corTuple *tuple1, corCArg val1);
};

typedef corHeapNode* HeapNodePtr;

/*****************************************************************************/

void cormerge_heaps(HeapNodePtr *rootptr, corHeapNode *left, corHeapNode *right,
    int order);
corTuple* corpop_heap(HeapNodePtr *heap, int order);
void corheap_insert(corHeapNode *heap, corTuple *tuple1, corCArg val1, int order);

/*****************************************************************************/

#endif _HashNode_H_

