// *************************************************************************
//    RuleEnv.h
// *************************************************************************

#ifndef _RuleEnv_H_
#define _RuleEnv_H_

#include "SemiNaive.h"
#include "ArrayBindEnv.h"
#include "StackMark.h"
//#include "TupleIterator.h"
#include "ArgList.h"
#include "Tuple.h"
#include "BindEnv.h"

// *************************************************************************

class corTupleIterator;

// *************************************************************************
//    Holds run time data structures for SemiNaive that need to be allocated
//    at every module invocation

class corRuleEnv {
public:
    int max_literals;    // needed for destructor
    corSemiNaive *parent_sn;
    corArrayBindEnv bindenv;
    corStackMark *rmarks;
    corTupleIterator **tuple_its;
    corArgList **arglist_its;
    corTuple **tuples ;
    corBindEnv **bindenvs; // For use by ReturnUnify code

    corRuleEnv(corSemiNaive *parent);
   ~corRuleEnv();
};

// *************************************************************************

#endif _RuleEnv_H_
