/*****************************************************************************/
//    DatabaseStruct.C
/*****************************************************************************/

#include "DatabaseStruct.h"
#include "Database.h"
#include "SymbolTable.h"

/*****************************************************************************/
corDatabaseStruct::~corDatabaseStruct()
{
    if (RelationTable) {
        if (strcmp(corSymbolString(name), COR_DB_RELS)) {
            corForEachTabElement(RelationTable, (Func)corclear_relation, 0) ;
        }
        delete RelationTable;
    }

   if (ModuleTable)
     delete ModuleTable;
}

/*****************************************************************************/

