//*********************************************************************
//    Globals.C
//*********************************************************************

#include "Globals.h"

#include "Trail.h"
#include "ConnectArray.h"

//*********************************************************************
// This class does _almost_ nothing, it is around to clear out the
// Symbol table after all the other destructors have finished and
// the program is exiting.  Thus its main purpose is to minimize the
// output of "purify" to allow real memory leaks to be more apparent.

corClearSym corclearSym;

//*********************************************************************

corTrail *corCurTrail = new corTrail(200);

    // This needs to change later?  Or always copy from default?
corExecutionEnv  cordeflt_exEnv;
corExecutionEnv *corexEnv = &cordeflt_exEnv;

corParserStruct  corparserStruct;
CoralConfig   coralConfig;

corTableStack corT_Stack(COR_MAX_RECURSION_DEPTH);

   // Pointer to the current ParseStack
corParseStack   *corparseStack = (corParseStack *) NULL;

   // Pointer to the top ParserEnv of the current ParseStack
corParserEnv    *corparseEnv   = (corParserEnv *) NULL;        

   // The current user, automagically kept up to date
corUser         *corcurUser    = (corUser *) NULL;

   // The current connection, automagically kept up to date
corConnection   *corcurConn    = (corConnection *)   NULL;

   // The connection array should only be addressed through the pointer
   // (where possible), this gives us the option of adding more someday.
corConnectArray  cordeflt_conn;
corConnectArray *corclients    = &cordeflt_conn;

//*********************************************************************

char coral_pid[32];        // Process Id of this coral program

//*********************************************************************
