/*****************************************************************************/
//    PipelinedDerivedRelation.h
/*****************************************************************************/

#ifndef _PipelinedDerivedRelation_H_
#define _PipelinedDerivedRelation_H_

#include "DerivedRelation.h"

/*****************************************************************************/

class corQFPipelinedModuleData;

/*****************************************************************************/

class corPipelinedDerivedRelation : public corDerivedRelation {
public:
    corQFPipelinedModuleData *md;
    int pred_offset;            //    offset of this relation in the pred_ptrs
                                //    array of the module

    corPipelinedDerivedRelation(corQFPipelinedModuleData *module,Name name,
        int arity);
    virtual corBindEnv* get_next(corTupleIterator&);
    virtual corTuple* get_next_tuple(corTupleIterator& it);
    virtual void release (corTupleIterator& it);
    virtual void print_name(FILE *file);    
};

/*****************************************************************************/

#endif _PipelinedDerivedRelation_H_

