/*****************************************************************************/
//    RelationStruct.h
/*****************************************************************************/

#ifndef _RelationStruct_H_
#define _RelationStruct_H_

#include "SymbolArg.h"

/*****************************************************************************/

class corRelation;

/*****************************************************************************/
// Contains a relation pointer and the name of the relation

class corRelationStruct {
public:
    corRelation *relPtr ;
    Name relName ;
    int relArity ;

    corRelationStruct() {
        relPtr = NULL;
        relName = NULL;
        relArity = 0;
    }
    void AssignVal(Name name, int arity);
    void AssignRel(corRelation *rel) { relPtr = rel; }
};

/*****************************************************************************/

#endif _RelationStruct_H_

