/*****************************************************************************/
//    TupleList.C
/*****************************************************************************/

#include "TupleList.h"

/*****************************************************************************/
void corTupleList::free_all()
{
    corTupleLink* next;

    for (corTupleLink *link = chain; link != NULL; link = next) {
        next = link->next;
        // This doesn't free the components of the tuple.
        delete link->tuple;
        delete link;
    }
    chain = NULL;
    lastptr = &chain;
}

/*****************************************************************************/

